Halide 22.0.0 Halide compiler and libraries

Public Member Functions | Protected Types | Protected Member Functions | List of all members
Halide::Internal::GeneratorInput_Func< T > Class Template Reference

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::GeneratorInput_Func< T >:

## Public Member Functions
| GeneratorInput_Func (const std::string &name, const Type &t, int d)
| GeneratorInput_Func (const std::string &name, int d)
| GeneratorInput_Func (const std::string &name, const Type &t)
| GeneratorInput_Func (const std::string &name)
| GeneratorInput_Func (size_t array_size, const std::string &name, const Type &t, int d)
| GeneratorInput_Func (size_t array_size, const std::string &name, int d)
| GeneratorInput_Func (size_t array_size, const std::string &name, const Type &t)
| GeneratorInput_Func (size_t array_size, const std::string &name)
template<typename... Args>
Expr | operator() (Args &&...args) const
Expr | operator() (const std::vector< Expr > &args) const
| operator Func () const
| operator ExternFuncArgument () const
GeneratorInput_Func< T > & | set_estimate (Var var, Expr min, Expr extent)
GeneratorInput_Func< T > & | set_estimates (const Region &estimates)
Func | in ()
Func | in (const Func &other)
Func | in (const std::vector< Func > &others)
Public Member Functions inherited from Halide::Internal::GeneratorInputImpl< T, Func >
size_t | size () const
const Func & | operator[] (size_t i) const
const Func & | at (size_t i) const
std::vector< Func >::const_iterator | begin () const
std::vector< Func >::const_iterator | end () const
Public Member Functions inherited from Halide::Internal::GeneratorInputBase
| ~GeneratorInputBase () override
Public Member Functions inherited from Halide::Internal::GIOBase
virtual | ~GIOBase ()=default
void | set_type (const Type &type)
void | set_dimensions (int dims)
void | set_array_size (int size)
| GIOBase (const GIOBase &)=delete
GIOBase & | operator= (const GIOBase &)=delete
| GIOBase (GIOBase &&)=delete
GIOBase & | operator= (GIOBase &&)=delete

## Protected Types
using | TBase = typename Super::TBase
Protected Types inherited from Halide::Internal::GeneratorInputImpl< T, Func >
using | TBase = std::remove_all_extents_t< T >

## Protected Member Functions
std::string | get_c_type () const override
template<typename T2 >
T2 | as () const
Protected Member Functions inherited from Halide::Internal::GeneratorInputImpl< T, Func >
bool | is_array () const override
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Protected Member Functions inherited from Halide::Internal::GeneratorInputBase
| GeneratorInputBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorInputBase (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Parameter | parameter () const
void | init_internals ()
void | set_inputs (const std::vector< StubInput > &inputs)
virtual void | set_def_min_max ()
void | verify_internals () override
virtual std::string | get_c_type () const =0
void | check_value_writable () const override
const char * | input_or_output () const override
void | set_estimate_impl (const Var &var, const Expr &min, const Expr &extent)
void | set_estimates_impl (const Region &estimates)
Protected Member Functions inherited from Halide::Internal::GIOBase
bool | array_size_defined () const
size_t | array_size () const
virtual bool | is_array () const
const std::string & | name () const
ArgInfoKind | kind () const
bool | gio_types_defined () const
const std::vector< Type > & | gio_types () const
Type | gio_type () const
bool | dims_defined () const
int | dims () const
const std::vector< Func > & | funcs () const
const std::vector< Expr > & | exprs () const
| GIOBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &types, int dims)
std::string | array_name (size_t i) const
virtual void | verify_internals ()
void | check_matching_array_size (size_t size) const
void | check_matching_types (const std::vector< Type > &t) const
void | check_matching_dims (int d) const
template<typename ElemType >
const std::vector< ElemType > & | get_values () const
void | check_gio_access () const
virtual void | check_value_writable () const =0
virtual const char * | input_or_output () const =0
template<>
const std::vector< Expr > & | get_values () const
template<>
const std::vector< Func > & | get_values () const

## Additional Inherited Members
Protected Attributes inherited from Halide::Internal::GeneratorInputBase
std::vector< Parameter > | parameters_
bool | inputs_set = false
Protected Attributes inherited from Halide::Internal::GIOBase
int | array_size_
const std::string | name_
const ArgInfoKind | kind_
std::vector< Type > | types_
int | dims_
std::vector< Func > | funcs_
std::vector< Expr > | exprs_
GeneratorBase * | generator {nullptr}

## Detailed Description

template<typename T>
class Halide::Internal::GeneratorInput_Func< T >

Definition at line 1827 of file Generator.h.

## Member Typedef Documentation

## ◆ TBase

template<typename T >

using Halide::Internal::GeneratorInput_Func< T >::TBase = typename Super::TBase
| protected

Definition at line 1832 of file Generator.h.

## Constructor & Destructor Documentation

## ◆ GeneratorInput_Func() [1/8]

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::GeneratorInput_Func | ( | const std::string & | name,
|  | const Type & | t,
|  | int | d
| ) |  |
| inline

Definition at line 1844 of file Generator.h.

## ◆ GeneratorInput_Func() [2/8]

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::GeneratorInput_Func | ( | const std::string & | name,
|  | int | d
| ) |  |
| inline

Definition at line 1849 of file Generator.h.

## ◆ GeneratorInput_Func() [3/8]

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::GeneratorInput_Func | ( | const std::string & | name,
|  | const Type & | t
| ) |  |
| inline

Definition at line 1854 of file Generator.h.

## ◆ GeneratorInput_Func() [4/8]

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::GeneratorInput_Func | ( | const std::string & | name | ) |
| inline explicit

Definition at line 1859 of file Generator.h.

## ◆ GeneratorInput_Func() [5/8]

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::GeneratorInput_Func | ( | size_t | array_size,
|  | const std::string & | name,
|  | const Type & | t,
|  | int | d
| ) |  |
| inline

Definition at line 1863 of file Generator.h.

## ◆ GeneratorInput_Func() [6/8]

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::GeneratorInput_Func | ( | size_t | array_size,
|  | const std::string & | name,
|  | int | d
| ) |  |
| inline

Definition at line 1868 of file Generator.h.

## ◆ GeneratorInput_Func() [7/8]

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::GeneratorInput_Func | ( | size_t | array_size,
|  | const std::string & | name,
|  | const Type & | t
| ) |  |
| inline

Definition at line 1873 of file Generator.h.

## ◆ GeneratorInput_Func() [8/8]

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::GeneratorInput_Func | ( | size_t | array_size,
|  | const std::string & | name
| ) |  |
| inline

Definition at line 1878 of file Generator.h.

## Member Function Documentation

## ◆ get_c_type()

template<typename T >

std::string Halide::Internal::GeneratorInput_Func< T >::get_c_type | ( |  | ) | const
| inline override protected virtual

Implements Halide::Internal::GeneratorInputBase.

Definition at line 1834 of file Generator.h.

## ◆ as()

template<typename T >
template<typename T2 >

T2 Halide::Internal::GeneratorInput_Func< T >::as | ( |  | ) | const
| inline protected

Definition at line 1839 of file Generator.h.

## ◆ operator()() [1/2]

template<typename T >
template<typename... Args>

Expr Halide::Internal::GeneratorInput_Func< T >::operator() | ( | Args &&... | args | ) | const
| inline

Definition at line 1883 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Internal::GIOBase::funcs().

## ◆ operator()() [2/2]

template<typename T >

Expr Halide::Internal::GeneratorInput_Func< T >::operator() | ( | const std::vector< Expr > & | args | ) | const
| inline

Definition at line 1888 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Internal::GIOBase::funcs().

## ◆ operator Func()

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::operator Func | ( |  | ) | const
| inline

Definition at line 1893 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Internal::GIOBase::funcs().

## ◆ operator ExternFuncArgument()

template<typename T >

Halide::Internal::GeneratorInput_Func< T >::operator ExternFuncArgument | ( |  | ) | const
| inline

Definition at line 1898 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Internal::GeneratorInputBase::parameters_.

## ◆ set_estimate()

template<typename T >

GeneratorInput_Func< T > & Halide::Internal::GeneratorInput_Func< T >::set_estimate | ( | Var | var,
|  | Expr | min,
|  | Expr | extent
| ) |  |
| inline

Definition at line 1903 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), Halide::Internal::min(), and Halide::Internal::GeneratorInputBase::set_estimate_impl().

## ◆ set_estimates()

template<typename T >

GeneratorInput_Func< T > & Halide::Internal::GeneratorInput_Func< T >::set_estimates | ( | const Region & | estimates | ) |
| inline

Definition at line 1909 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Internal::GeneratorInputBase::set_estimates_impl().

## ◆ in() [1/3]

template<typename T >

Func Halide::Internal::GeneratorInput_Func< T >::in | ( |  | ) |
| inline

Definition at line 1915 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Func::in().

## ◆ in() [2/3]

template<typename T >

Func Halide::Internal::GeneratorInput_Func< T >::in | ( | const Func & | other | ) |
| inline

Definition at line 1920 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Func::in().

## ◆ in() [3/3]

template<typename T >

Func Halide::Internal::GeneratorInput_Func< T >::in | ( | const std::vector< Func > & | others | ) |
| inline

Definition at line 1925 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Func::in().

The documentation for this class was generated from the following file:

- src/Generator.h